<?php 
/*
===========================================================
|                  *  *                     |
-----------------------------------------------------------
| ICQ: 248932                                       |
| E-mail: pavilion@epage.ru                  |

-----------------------------------------------------------
| Copyright (c) 2009, .      http://pautina.at     |
-----------------------------------------------------------
===========================================================
|       *      *         |
===========================================================
*/
class image
{
	/** 
	 * img_resize generation thumbnails and avatar
	 *
	 * @param  $src 		file names
	 * @param  $dest 		name generation file
	 * @param  $width 	 	width generation file
	 * @param  $height		height generation file
	 * @param  $rgb		  	fon color
	 * @param  $quality	  	quality
	 * 
	 * @return bool		  	true or false
	 * 
	 */
	function img_resize($src, $dest, $width, $height, $rgb=0xFFFFFF, $quality=100)
	{
	  if (!file_exists($src)) return false;
	
	  $size = getimagesize($src);
	
	  if ($size === false) return false;
	
	  // Define source format on MIME-information, given
	  // function getimagesize, and choose corresponding to format
	  // imagecreatefrom-function.
	  $format = strtolower(substr($size['mime'], strpos($size['mime'], '/')+1));
	  $icfunc = "imagecreatefrom" . $format;
	  if (!function_exists($icfunc)) return false;
	
	  $x_ratio = $width / $size[0];
	  $y_ratio = $height / $size[1];
	
	  $ratio       = min($x_ratio, $y_ratio);
	  $use_x_ratio = ($x_ratio == $ratio);
	
	  $new_width   = $use_x_ratio  ? $width  : floor($size[0] * $ratio);
	  $new_height  = !$use_x_ratio ? $height : floor($size[1] * $ratio);
	  $new_left    = $use_x_ratio  ? 0 : floor(($width - $new_width) / 2);
	  $new_top     = !$use_x_ratio ? 0 : floor(($height - $new_height) / 2);
	
	  $isrc = $icfunc($src);
	  $idest = imagecreatetruecolor($width, $height);
	  imagefill($idest, 0, 0, $rgb);
	  imagecopyresampled($idest, $isrc, 0, 0, 0, 0, 
	    $new_width, $new_height, $size[0], $size[1]);
	
	  imagejpeg($idest, $dest, $quality);
	
	  imagedestroy($isrc);
	  imagedestroy($idest);
	  return true;
	}
	
	/**
	 * Generate out file names
	 *
	 * @param [userId]		id user's
	 * @param [arrFile]		array $_FILES['name'], source file
	 * 
	 * @return [filename]   out file name's
	 */
	function  doGenerateName($userId, $arrFile)
	{
		$arrFileProperty = getimagesize($arrFile['tmp_name']);
		switch($arrFileProperty[2])
		{
			case (1):
			{
				$filename = $userId.'.gif';
				break;
			}
			case (2):
			{
				$filename = $userId.'.jpg';
				break;
			}
			case (3):
			{
				$filename = $userId.'.png';
				break;
			}
		}
		return $filename;
	}
}
?>